# frozen_string_literal: true

module Course
  class Result
    attr_reader :failure, :output

    def initialize(output: nil, failure: nil)
      @output = output
      @failure = failure
    end

    def failure?
      !success?
    end

    def on_fail
      yield failure if block_given? && failure?
    end

    def success?
      failure.nil?
    end

    def on_success
      yield output if block_given? && success?
    end
  end
end
